// BeWitch ver.0.08  2003.5.3
#include	"bewitch.h"

#define	BW_VER	0x08

int main()
{
	bw_area_size=((bw_area_size-1)/B_PAGE_SIZE+1)*B_PAGE_SIZE;
	bw_area_id=create_area("bewitch",(void**)&bw_area_adr,B_ANY_ADDRESS,bw_area_size,B_CONTIGUOUS,B_READ_AREA|B_WRITE_AREA);
	if(bw_area_id<=0)printf("error : create_area\n");
	printf("ok : area_id=%d  size=%04x\n",bw_area_id,bw_area_size);
	for(int i=0;i<bw_area_size;i++)bw_area_adr[i]=0;
	*(bw_area_adr+bw_flag_init_adr)=0xff;	//not-init
	slp=0x00;								//not-sleep vblank/sound/comm
	*(bw_area_adr+bw_ver_adr)=BW_VER;
	
	*(bw_area_adr+bw_hard_adr)=1;		//color

	BW_app	bw_app;
	bw_app.Run();

	return(true);
}

int32 vblank(void* data)
{
	ulong		*t=(ulong*)(bw_area_adr+bw_tick_adr);
	short		k,kk,kt,cf,ct;
	key_info	key;
	kk=0;kt=-1;
	cf=0;ct=-1;

	while(1){
		snooze(bw_vb_t);	// 13000..for VBLANK(13.333msec)
		if(*(bw_area_adr+bw_flag_init_adr)|slp&0x01)continue;	//sleep
//tickcount
		(*t)++;
//keyscan
		get_key_info(&key);
		k=0;
		if(key.key_states[7]&0x04)k|=0x0002;	//start		's'
		if(key.key_states[7]&0x08)k|=0x0004;	//a			'a'
		if(key.key_states[10]&0x80)k|=0x0008;	//b			'b'
		if(mode&2){		//tate
			if(key.key_states[7]&0x80)k|=0x0020;	//x2		'ten-8'
			if(key.key_states[9]&0x20)k|=0x0040;	//x3		'ten-6
			if(key.key_states[11]&0x40)k|=0x0080;	//x4		'ten-2'
			if(key.key_states[9]&0x80)k|=0x0010;	//x1		'ten-4'
			if(key.key_states[10]&0x01)k|=0x0200;	//y2		'up'
			if(key.key_states[12]&0x10)k|=0x0400;	//y3		'right'
			if(key.key_states[12]&0x20)k|=0x0800;	//y4		'down'
			if(key.key_states[12]&0x40)k|=0x0100;	//y1		'left'
		}else{			//yoko(normal)
			if(key.key_states[7]&0x80)k|=0x0010;	//x1		'ten-8'
			if(key.key_states[9]&0x20)k|=0x0020;	//x2		'ten-6
			if(key.key_states[11]&0x40)k|=0x0040;	//x3		'ten-2'
			if(key.key_states[9]&0x80)k|=0x0080;	//x4		'ten-4'
			if(key.key_states[10]&0x01)k|=0x0100;	//y1		'up'
			if(key.key_states[12]&0x10)k|=0x0200;	//y2		'right'
			if(key.key_states[12]&0x20)k|=0x0400;	//y3		'down'
			if(key.key_states[12]&0x40)k|=0x0800;	//y4		'left'
		}
		*(short*)(bw_area_adr+bw_key_adr)=k;
		if(~kk&k){	//new key
			*(short*)(bw_area_adr+bw_key_hit_adr)|=~kk&k;
		}
		if((k)&&(k==kk)){
			if(*(bw_area_adr+bw_key_rep_adr+1)){
				if(kt--==0){
					kk=0;
					kt=*(bw_area_adr+bw_key_rep_adr);	//repeat rate
				}
			}
		}else{
			kt=*(bw_area_adr+bw_key_rep_adr+1);			//repeat delay
		}
		if(~kk&k){	//new key (repeat)
			*(short*)(bw_area_adr+bw_key_hitr_adr)|=~kk&k;
		}
		kk=k;
//cursor
		if((cf)&&(*(bw_area_adr+bw_cur_adr)==0)){	//off
			cf=0;ct=0;
		}
		if((cf==0)&&(*(bw_area_adr+bw_cur_adr))){	//on
			cf=3;ct=0;
		}
		if(ct>0)if(--ct==0)cf^=2;
		if(ct==0){
			*(bw_area_adr+bw_cur_stt_adr)=cf;
			ct=*(bw_area_adr+bw_cur_type_adr+1);
			if((cf==0)||(ct==0))ct=-1;
		}
	}
}

int32 sound(void* data)
{
	char	sf[4];		//playing flag  0.off  1.normal  2.effect
	uchar	gsd[4][32];
	struct gs_attribute	gsa[4];
	struct gs_audio_format	gsf[4];
	BSimpleGameSound	*gs[4];
	ushort	swp,swt;	//sweep mode : now-pitch next-change-time
	for(int i=0;i<4;i++)sf[i]=0;
	while(1){
		snooze(2600);	//for sweep(2.667msec)
		if(*(bw_area_adr+bw_flag_init_adr)|slp&0x02){	//sleep
			for(int i=0;i<4;i++)if(sf[i]){
				gs[i]->StopPlaying();
				delete gs[i];gs[i]=NULL;
				sf[i]=0;
			}
			continue;
		}
		uchar	uf=*(bw_area_adr+bw_flag_sound_adr);
		if(uf)*(bw_area_adr+bw_flag_sound_adr)=0;

		if(sf[2]==2){							//sweep
			if(swt){swt--;}
			else{
				swt=*(bw_area_adr+bw_snd_sweep_adr+1);
				swp+=*(char*)(bw_area_adr+bw_snd_sweep_adr);
				swp&=0x07ff;
				gsa[2].attribute=B_GS_SAMPLING_RATE;
				gsa[2].duration=0;
				gsa[2].value=3072000/((2048-swp)*32)*32;
				gsa[2].flags=0;
				gs[2]->SetAttributes(&(gsa[2]),1);
			}
		}

		for(int i=0;i<4;i++)if(uf&(0x01<<i)){	//update
			if(sf[i]){	//stop
				gs[i]->StopPlaying();
				delete gs[i];gs[i]=NULL;
				sf[i]=0;
			}
			if(*(bw_area_adr+bw_snd_ch_adr)&(0x01<<i)){
				sf[i]=(*(bw_area_adr+bw_snd_ch_adr)&(0x10<<i))?2:1;
				for(int j=0;j<16;j++){
					uchar	*p=bw_area_adr+bw_snd_wave_adr+i*16+j;
					gsd[i][j*2]=(*p)&0x0f;gsd[i][j*2]=gsd[i][j*2]*0x10+8;
					gsd[i][j*2+1]=(*p)>>4;gsd[i][j*2+1]=gsd[i][j*2+1]*0x10+8;
				}
				int	pt=*(ushort*)(bw_area_adr+bw_snd_pitch_adr+i*2);
				if((i==2)&&(sf[2]==2)){swp=pt;swt=*(bw_area_adr+bw_snd_sweep_adr+1);}
				gsf[i].frame_rate=3072000/((2048-pt)*32)*32;
				gsf[i].channel_count=1;
				gsf[i].format=0x11;		//B_GS_U8(1-255);
				gsf[i].byte_order=2;	//little-endian
				gsf[i].buffer_size=32;
				gs[i]=new BSimpleGameSound(gsd[i],32,&(gsf[i]));
				uchar	vl,vr;
				vl=*(bw_area_adr+bw_snd_vol_adr+i)&0x0f;
				vr=*(bw_area_adr+bw_snd_vol_adr+i)>>4;
				gs[i]->SetGain((float)vl/16+(float)vr/16);
				gs[i]->SetIsLooping(true);
				gs[i]->StartPlaying();
			}
		}
	}
}

int32 comm(void* data)
{
	BSerialPort	com;
	bool	f=false;	// comm open?
	uchar	*buf=bw_area_adr+bw_com_buf_adr;
	int32	stt,len,bc;
	while(1){
		snooze(10000);	//0.01sec
		if(*(bw_area_adr+bw_flag_init_adr)|slp&0x04){	//sleep
			com.Close();
			f=false;
			continue;
		}
		uchar	cmd=*(bw_area_adr+bw_com_cmd_adr);
		if(cmd==0)continue;
		if(cmd==1){			//open
			stt=com.Open("/dev/ports/serial1");
			f=true;
			com.SetFlowControl(0);//B_HARDWARE_CONTROL);
			com.SetDataBits(B_DATA_BITS_8);
			com.SetStopBits(B_STOP_BITS_1);
			com.SetParityMode(B_NO_PARITY);
			*(bw_area_adr+bw_com_cmd_adr)=0;
		}
		if(cmd==2){			//close
			com.Close();
			f=false;
			*(bw_area_adr+bw_com_cmd_adr)=0;
		}
		if(cmd==4){			//send
			len=*(ushort*)(bw_area_adr+bw_com_len_adr);
			int	to=*(short*)(bw_area_adr+bw_com_tout_adr+2);
			com.SetDataRate(*(bw_area_adr+bw_com_bps_adr)?B_38400_BPS:B_9600_BPS);
			stt=com.Write(buf,len);
			*(ushort*)(bw_area_adr+bw_com_len_adr)=stt;
			*(short*)(bw_area_adr+bw_com_stt_adr)=0;
			*(bw_area_adr+bw_com_cmd_adr)=0;
		}
		if(cmd==8){			//recv
			len=*(ushort*)(bw_area_adr+bw_com_len_adr);
			int	to=*(short*)(bw_area_adr+bw_com_tout_adr);
			com.SetDataRate(*(bw_area_adr+bw_com_bps_adr)?B_38400_BPS:B_9600_BPS);
			if(to<0){
				bc=len;
				com.NumCharsAvailable(&bc);
				stt=com.Read(buf,len);
			}else{
				com.SetTimeout(to*13333);
				com.SetBlocking(to!=0);
				for(bc=0;bc<len;bc++){
					stt=com.Read(buf+bc,1);
					if(stt<1)break;
				}
			}
			*(ushort*)(bw_area_adr+bw_com_len_adr)=bc;
			*(short*)(bw_area_adr+bw_com_stt_adr)=(stt<len)?0x8101:0;
			*(bw_area_adr+bw_com_cmd_adr)=0;
		}
	}
}
//------------------------------------------------------------------
BW_app::BW_app(void):BApplication("application/x-vnd.Beer-bewitch")
{
	mode=4;		//b0..normal/reverse  b1..tate/yoko  b2..gray/color
	bw_w=new BW_con_win(BRect(320,50,519,99),"BeWitch");
	bw_cw=new BW_chr_win(BRect(30,30,285,285),"character");
	bw_pw=new BW_pal_win(BRect(320,158,447,285),"palette");
	bw_s0w=new BW_scr_win(BRect(30,320,285,575),"sprite",0);
	bw_s1w=new BW_scr_win(BRect(300,320,555,575),"screen1",1);
	bw_s2w=new BW_scr_win(BRect(570,320,825,575),"screen2",2);
	bw_lw=new BW_lcd_win(BRect(570,40,809,183),"lcd");
	bw_vb_id=spawn_thread(vblank,"vblank",B_NORMAL_PRIORITY,NULL);
	resume_thread(bw_vb_id);
	bw_snd_id=spawn_thread(sound,"sound",B_NORMAL_PRIORITY,NULL);
	resume_thread(bw_snd_id);
	bw_com_id=spawn_thread(comm,"comm",B_NORMAL_PRIORITY,NULL);
	resume_thread(bw_com_id);
}

bool BW_app::QuitRequested()
{
	kill_thread(bw_vb_id);
	kill_thread(bw_snd_id);
	kill_thread(bw_com_id);
	return(true);
}

void BW_app::MessageReceived(BMessage *mes)
{
	switch(mes->what){
		case 'chkb':{
			const char	*name;
			if(!mes->FindString("name",&name)){
				if(!strcmp(name,"sound")){
//					if(bw_w->bw_v->bw_pr_cb[0]->Value())resume_thread(bw_snd_id);
//					else suspend_thread(bw_snd_id);
					if(bw_w->bw_v->bw_pr_cb[0]->Value())slp&=~0x02;
					else slp|=0x02;
				}
				if(!strcmp(name,"serial")){
//					if(bw_w->bw_v->bw_pr_cb[1]->Value())resume_thread(bw_com_id);
//					else suspend_thread(bw_com_id);
					if(bw_w->bw_v->bw_pr_cb[1]->Value())slp&=~0x04;
					else slp|=0x04;
				}
			}
		}break;
		default:{
			BApplication::MessageReceived(mes);
		}break;
	}
}
//------------------------------------------------------------------
BW_con_win::BW_con_win(BRect frame,char *title):BWindow(frame,title,B_TITLED_WINDOW,B_NOT_RESIZABLE)
{
	bw_v=new BW_con_view(BRect(0,0,200,200),title);
	AddChild(bw_v);
	Show();
	SetPulseRate(300000);	/* 0.3sec */
}

bool BW_con_win::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}

void BW_con_win::Zoom(BPoint rec_position,float rec_width,float rec_height)
{
	if((Bounds().Width()==199)&&(Bounds().Height()==199)){
		ResizeTo(199,49);
	}else{
		ResizeTo(199,199);
	}
}
//------------------------------------------------------------------
BW_chr_win::BW_chr_win(BRect frame,char *title):BWindow(frame,title,B_TITLED_WINDOW,B_NOT_CLOSABLE|B_NOT_ZOOMABLE|B_NOT_RESIZABLE)
{
	winf=1;
	bw_cv=new BW_chr_view(BRect(0,0,255,255),title);
	AddChild(bw_cv);
	SetPulseRate(250000);	/* 0.25sec */
	Show();
}

bool BW_chr_win::QuitRequested()
{
	return(true);
}

void BW_chr_win::changemode()
{
	if((*(bw_area_adr+bw_col_mode_adr)&0xc0)==0xc0){
		winf=1;
		ResizeTo(255,255);
	}else{
		winf=0;
		ResizeTo(255,127);
	}
}
//------------------------------------------------------------------
BW_pal_win::BW_pal_win(BRect frame,char *title):BWindow(frame,title,B_TITLED_WINDOW,B_NOT_CLOSABLE|B_NOT_ZOOMABLE|B_NOT_RESIZABLE)
{
	bw_pv=new BW_pal_view(BRect(0,0,127,127),title);
	AddChild(bw_pv);
	SetPulseRate(250000);	/* 0.25sec */
	Show();
}

bool BW_pal_win::QuitRequested()
{
	return(true);
}
//------------------------------------------------------------------
BW_scr_win::BW_scr_win(BRect frame,char *title,int no):BWindow(frame,title,B_TITLED_WINDOW,B_NOT_CLOSABLE|B_NOT_ZOOMABLE|B_NOT_RESIZABLE)
{
	bw_sv=new BW_scr_view(BRect(0,0,255,255),title,no);
	AddChild(bw_sv);
	SetPulseRate(100000);	/* 0.1sec */
	Show();
}

bool BW_scr_win::QuitRequested()
{
	return(true);
}
//------------------------------------------------------------------
BW_lcd_win::BW_lcd_win(BRect frame,char *title):BWindow(frame,title,B_TITLED_WINDOW,B_NOT_CLOSABLE|B_NOT_ZOOMABLE|B_NOT_RESIZABLE)
{
	winf=4;
	bw_lv=new BW_lcd_view(BRect(0,0,223,143),"lcd_main");
	AddChild(bw_lv);
	bw_segv=new BW_seg_view(BRect(0,0,15,143),"lcd_seg");
	AddChild(bw_segv);
	SetPulseRate(100000);	/* 0.1sec */
	Show();
}

bool BW_lcd_win::QuitRequested()
{
	return(true);
}

void BW_lcd_win::changemode()
{
	if((mode&6)==0)ResizeTo(223,143+16);
	else if((mode&6)==2)ResizeTo(143+16,223);
	else if((mode&6)==4)ResizeTo(223+16,143);
	else ResizeTo(143,223+16);
	winf=mode;
}
//------------------------------------------------------------------
BW_con_view::BW_con_view(BRect frame,char *title):BView(frame,title,B_NOT_RESIZABLE,B_WILL_DRAW/*|B_PULSE_NEEDED*/)
{
	BMessage	*mes;
	mes=new BMessage('slid');
	mes->AddString("name","speed_vblank");
	bw_vb_sl=new BSlider(BRect(20,128,180,170),"vb_sl","speed(vblank)",mes,1000,100000,B_TRIANGLE_THUMB);
	bw_vb_sl->SetValue(13000);
	bw_vb_sl->SetLimitLabels("fast","slow");
	AddChild(bw_vb_sl);
	for(int i=0;i<8;i++){
		mes=new BMessage('radb');
		mes->AddString("name","mode");
		bw_mc_rb[i]=new BRadioButton(BRect((i&3)*30+70,(i/4)*15+70,(i&3)*30+84,(i/4)*15+84),"mode","",mes);
		bw_mc_rb[i]->SetValue(i==4);
		AddChild(bw_mc_rb[i]);
	}
	mes=new BMessage('chkb');
	mes->AddString("name","sound");
	bw_pr_cb[0]=new BCheckBox(BRect(20,106,90,120),"pr_cb_sound","sound",mes);
	bw_pr_cb[0]->SetValue(1);
	AddChild(bw_pr_cb[0]);
	mes=new BMessage('chkb');
	mes->AddString("name","serial");
	bw_pr_cb[1]=new BCheckBox(BRect(110,106,180,120),"pr_cb_serial","serial",mes);
	bw_pr_cb[1]->SetValue(1);
	AddChild(bw_pr_cb[1]);
}

void BW_con_view::AttachedToWindow()
{
	SetViewColor(224,224,224);		SetLowColor(120,140,170);
	SetFont(be_bold_font);
	MakeFocus();
	bw_vb_sl->SetTarget(this);
	for(int i=0;i<8;i++)bw_mc_rb[i]->SetTarget(this);
	for(int i=0;i<2;i++)bw_pr_cb[i]->SetTarget(be_app);
}

void BW_con_view::Draw(BRect rect)
{
	SetFontSize(10);
	SetHighColor(0,0,0);	SetLowColor(224,224,224);
	DrawString("n-yoko-r       n-tate-r",BPoint(70,65));
	DrawString("grayswan",BPoint(17,80));
	DrawString("colorswan",BPoint(15,95));

	StrokeRect(BRect(10,53,189,105));
	StrokeRect(BRect(10,105,189,125));
	StrokeRect(BRect(10,125,189,180));
	SetHighColor(100,100,100);	SetLowColor(224,224,224);
	FillRoundRect(BRect(2,2,197,47),10,10);
	FillRoundRect(BRect(70,182,197,197),10,10);
	SetHighColor(160,160,160);	SetLowColor(224,224,224);
	FillEllipse(BRect(15,10,41,36));

	SetFontSize(18);
	SetHighColor(203,0,51);		SetLowColor(213,112,137);	DrawString("e",BPoint(30,30));
	SetHighColor(0,51,152);		SetLowColor(112,137,188);	DrawString("B",BPoint(20,30));
	SetHighColor(222,255,255);	SetLowColor(111,128,128);	DrawString("Witch",BPoint(45,30));
	SetFontSize(15);
	DrawString("ver.0.08",BPoint(120,20));
	SetFontSize(12);
	DrawString("( 2003. 5. 3 )",BPoint(110,40));
	DrawString("(c)Beer/Won-wan",BPoint(84,194));
}

void BW_con_view::MessageReceived(BMessage *mes)
{
	switch(mes->what){
		case 'slid':{
			const char	*name;
			if(!mes->FindString("name",&name))bw_vb_t=bw_vb_sl->Value();
		}break;
		case 'radb':{
			const char	*name;
			if(!mes->FindString("name",&name))for(int i=0;i<8;i++)if(bw_mc_rb[i]->Value())mode=i;
			*(bw_area_adr+bw_hard_adr)=(mode&4)?1:0;
			((BW_app*)be_app)->bw_lw->changemode();
		}break;
		default:{
			BView::MessageReceived(mes);
		}break;
	}
}
//------------------------------------------------------------------
BW_chr_view::BW_chr_view(BRect frame,char *title):BView(frame,title,B_NOT_RESIZABLE,B_WILL_DRAW|B_PULSE_NEEDED)
{
	viewf=1;
	bm=new BBitmap(BRect(0,0,255,255),B_RGB_32_BIT);
	uint32	*bmp=(uint32*)(bm->Bits());
	for(int i=0;i<1024*64;i++)*(bmp++)=0;
}

void BW_chr_view::AttachedToWindow()
{
}

void BW_chr_view::Draw(BRect rect)
{
	DrawBitmap(bm,BPoint(0,0));
}

void BW_chr_view::Pulse()
{
if(*(bw_area_adr+bw_flag_init_adr))return;
	static uint32	chrviewpal[16]={
		0x000000,0x444444,0x555555,0x666666,0x777777,0x888888,0x999999,0xaaaaaa,
		0xbbbbbb,0xcccccc,0xd7d7d7,0xdfdfdf,0xe7e7e7,0xefefef,0xf7f7f7,0xffffff	};
	uint32	*bmp=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
if(*(bw_area_adr+bw_col_mode_adr)==0xc0){	//COLOR_MODE_16COLOR
	if(viewf!=1){((BW_app*)be_app)->bw_cw->changemode();viewf=1;}
	uchar	*p=bw_area_adr+bw_col_chr_adr;
	for(int i=0;i<1024;i++){
		int	x=(i%32)*8;
		int	y=(i/32)*8;
		for(int	j=0;j<8;j++){
			uint32	*q=bmp+y*dy+x;
			for(uchar b=0x80;b;b>>=1){
				int	c=0;
				if(*p&b)c|=1;
				if(*(p+1)&b)c|=2;
				if(*(p+2)&b)c|=4;
				if(*(p+3)&b)c|=8;
//				*(q++)=0x111111*c;//rgb
				*(q++)=chrviewpal[c];//rgb
			}
			p+=4;
			y++;
		}
	}
}else if(*(bw_area_adr+bw_col_mode_adr)==0xe0){	//COLOR_MODE_16PACKED
	if(viewf!=1){((BW_app*)be_app)->bw_cw->changemode();viewf=1;}
	uchar	*p=bw_area_adr+bw_col_chr_adr;
	for(int i=0;i<1024;i++){
		int	x=(i%32)*8;
		int	y=(i/32)*8;
		for(int	j=0;j<8;j++){
			uint32	*q=bmp+y*dy+x;
			for(int k=0;k<8;k++){
				int	c=((*(p+k/2))>>((k&1)?0:4))&0xf;
///c|=c<<2;
//				*(q++)=0x111111*c;//rgb
				*(q++)=chrviewpal[c];//rgb
			}
			p+=4;
			y++;
		}
	}
}else{											//GRAYSCALE,4COLOR
	if(viewf!=0){((BW_app*)be_app)->bw_cw->changemode();viewf=0;}
	uchar	*p=bw_area_adr+bw_chr_adr;
	for(int i=0;i<512;i++){
		int	x=(i%32)*8;
		int	y=(i/32)*8;
		for(int	j=0;j<8;j++){
			uint32	*q=bmp+y*dy+x;
			for(uchar b=0x80;b;b>>=1){
				int	c=0;
				if(*p&b)c|=1;
				if(*(p+1)&b)c|=2;
//				*(q++)=0x555555*c;//rgb
				*(q++)=chrviewpal[c*5];//rgb
			}
			p+=2;
			y++;
		}
	}
	uint32	*q=bmp+128*dy;
	for(int i=0;i<512*64;i++)*(q++)=0;
}
	DrawBitmap(bm,BPoint(0,0));
}
//------------------------------------------------------------------
BW_pal_view::BW_pal_view(BRect frame,char *title):BView(frame,title,B_NOT_RESIZABLE,B_WILL_DRAW|B_PULSE_NEEDED)
{
	bm=new BBitmap(BRect(0,0,127,127),B_RGB_32_BIT);
	uint32	*bmp=(uint32*)(bm->Bits());
	for(int i=0;i<256*64;i++)*(bmp++)=0;
}

void BW_pal_view::AttachedToWindow()
{
}

void BW_pal_view::Draw(BRect rect)
{
	DrawBitmap(bm,BPoint(0,0));
}

void BW_pal_view::Pulse()
{
if(*(bw_area_adr+bw_flag_init_adr))return;
	uint32	*bmp=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
if(*(bw_area_adr+bw_col_mode_adr)==0x00){		//GRAYSCALE
	for(int y=0;y<16;y++)for(int x=0;x<4;x++){
		ushort	pc=*(ushort*)(bw_area_adr+bw_chr_pal_adr+y*2);
		uchar	lc=*(bw_area_adr+bw_lcd_pal_adr+((pc>>(4*x))&0x07));
		uint32	c=lc*0x111111;
		for(int yy=0;yy<8;yy++)for(int xx=0;xx<32;xx++){
			uint32	*q=bmp+(y*8+yy)*dy+x*32+xx;
			*q=c;
		}
	}
}else if(*(bw_area_adr+bw_col_mode_adr)==0x80){	//4COLOR
	for(int y=0;y<16;y++)for(int x=0;x<4;x++){
		ushort	pc=*(ushort*)(bw_area_adr+bw_col_pal_adr+y*32+x*2);
		uint32	c=((pc&0xf00)*0x1100)|((pc&0xf0)*0x110)|((pc&0xf)*0x11);
		for(int yy=0;yy<8;yy++)for(int xx=0;xx<32;xx++){
			uint32	*q=bmp+(y*8+yy)*dy+x*32+xx;
			*q=c;
		}
	}
}else{											//16COLOR,16PACKED
	for(int y=0;y<16;y++)for(int x=0;x<16;x++){
		ushort	pc=*(ushort*)(bw_area_adr+bw_col_pal_adr+y*32+x*2);
		uint32	c=((pc&0xf00)*0x1100)|((pc&0xf0)*0x110)|((pc&0xf)*0x11);
		for(int yy=0;yy<8;yy++)for(int xx=0;xx<8;xx++){
			uint32	*q=bmp+(y*8+yy)*dy+x*8+xx;
			*q=c;
		}
	}
}
	DrawBitmap(bm,BPoint(0,0));
}
//------------------------------------------------------------------
BW_scr_view::BW_scr_view(BRect frame,char *title,int no):BView(frame,title,B_NOT_RESIZABLE,B_WILL_DRAW|B_PULSE_NEEDED)
{
	bm=new BBitmap(BRect(0,0,255,255),B_RGB_32_BIT);
	uint32	*bmp=(uint32*)(bm->Bits());
	for(int i=0;i<1024*64;i++)*(bmp++)=0;
	sn=no;
	bw_sbm[no]=bm;
}

void BW_scr_view::AttachedToWindow()
{
}

void BW_scr_view::Draw(BRect rect)
{
	DrawBitmap(bm,BPoint(0,0));
}

void BW_scr_view::Pulse()
{
if(*(bw_area_adr+bw_flag_init_adr))return;
	uint32	*bmp=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;

	if(sn==0){	//sprite
		uint32	*q=bmp;
		for(int i=0;i<1024*64;i++)*(q++)=0;
		bool	sw=(*(bw_area_adr+bw_disp_adr)&0x08);	//win mode
		int	swl=*(bw_area_adr+bw_spr_win_adr);
		int	swt=*(bw_area_adr+bw_spr_win_adr+1);
		int	swr=*(bw_area_adr+bw_spr_win_adr+2)+swl;
		int	swb=*(bw_area_adr+bw_spr_win_adr+3)+swt;
//		int	swl=sw?*(bw_area_adr+bw_spr_win_adr):0;
//		int	swt=sw?*(bw_area_adr+bw_spr_win_adr+1):0;
//		int	swr=sw?*(bw_area_adr+bw_spr_win_adr+2)+swl:255;
//		int	swb=sw?*(bw_area_adr+bw_spr_win_adr+3)+swt:255;
		if((swr>255)||(swb>255))return;	//===error===
//printf("spr win=(%d %d %d %d)\n",swl,swt,swr,swb);
		uchar	*sp=bw_area_adr+bw_spr_adr;
		uint32	c[16][16];
		uchar	*cp,*cpp,*lpp;
if(*(bw_area_adr+bw_col_mode_adr)==0x00){		//GRAYSCALE
		cp=bw_area_adr+bw_chr_adr;
		cpp=bw_area_adr+bw_chr_pal_adr;
		lpp=bw_area_adr+bw_lcd_pal_adr;
		for(int i=8;i<16;i++){
			ushort	pc=*(ushort*)(cpp+i*2);				//pal_cols=8-15x4
			for(int j=0;j<4;j++){
				uchar	lc=*(lpp+(pc&0x07));
				c[i][j]=((i&4)&&(j==0))?0:0x04000000|(0x111111*lc);
				c[i-8][j]=((i&4)&&(j==0))?0:0x02000000|(0x111111*lc);
				pc>>=4;
			}
		}
}else if(*(bw_area_adr+bw_col_mode_adr)==0x80){	//4COLOR
		cp=bw_area_adr+bw_chr_adr;
		cpp=bw_area_adr+bw_col_pal_adr;
		for(int i=8;i<16;i++){
			for(int j=0;j<4;j++){
				ushort	pc=*(ushort*)(cpp+i*32+j*2);	//pal_cols=8-15x4
				uint32	lc=((pc&0xf00)*0x1100)|((pc&0xf0)*0x110)|((pc&0xf)*0x11);
				c[i][j]=((i&4)&&(j==0))?0:0x04000000|lc;
				c[i-8][j]=((i&4)&&(j==0))?0:0x02000000|lc;
			}
		}
}else{											//16COLOR
		cp=bw_area_adr+bw_col_chr_adr;
		cpp=bw_area_adr+bw_col_pal_adr;
		for(int i=8;i<16;i++){
			for(int j=0;j<16;j++){
				ushort	pc=*(ushort*)(cpp+i*32+j*2);	//pal_cols=8-15x16
				uint32	lc=((pc&0xf00)*0x1100)|((pc&0xf0)*0x110)|((pc&0xf)*0x11);
				c[i][j]=(j==0)?0:0x04000000|lc;
				c[i-8][j]=(j==0)?0:0x02000000|lc;
			}
		}
}
		int	sl=*(bw_area_adr+bw_spr_rg_adr+1);
		int	se=*(bw_area_adr+bw_spr_rg_adr)+sl-1;
		sp+=se*4;
		for(int i=0;i<sl;i++){
			int	cn=*sp+((*(sp+1)&1)<<8);	//chr no=0-511
			int	pn=(*(sp+1)&0x0e)>>1;		//pal no-8=0-7
			bool	ct=*(sp+1)&0x10;		//ct
			if(*(sp+1)&0x20)pn+=8;			//pri
			int	xx=(*(sp+1)&0x40)?-1:1;		//h-mirror
			int	yy=(*(sp+1)&0x80)?-1:1;		//v-mirror
			uchar	x=*(sp+2);if(xx<0)x+=7;
			uchar	y=*(sp+3);if(yy<0)y+=7;
if(*(bw_area_adr+bw_col_mode_adr)==0xc0){	//COLOR_MODE_16COLOR
			uchar	*p=cp+cn*32;
			for(int	j=0;j<8;j++){
				for(uchar b=0x80;b;b>>=1){
//					bool	f=((x>=swl)&&(x<=swr)&&(y>=swt)&&(y<=swb))^ct;
					bool	f=(!sw)||(((x>=swl)&&(x<=swr)&&(y>=swt)&&(y<=swb))^ct);
					if(f){
						int	cc=0;
						if(*p&b)cc|=1;
						if(*(p+1)&b)cc|=2;
						if(*(p+2)&b)cc|=4;
						if(*(p+3)&b)cc|=8;
						if(c[pn][cc])*(bmp+y*dy+x)=c[pn][cc];
					}
					x+=xx;
				}
				x-=xx*8;
				y+=yy;
				p+=4;
			}
}else if(*(bw_area_adr+bw_col_mode_adr)==0xe0){	//COLOR_MODE_16PACKED
			uchar	*p=cp+cn*32;
			for(int	j=0;j<8;j++){
				for(int k=0;k<8;k++){
//					bool	f=((x>=swl)&&(x<=swr)&&(y>=swt)&&(y<=swb))^ct;
					bool	f=(!sw)||(((x>=swl)&&(x<=swr)&&(y>=swt)&&(y<=swb))^ct);
					if(f){
						int	cc=((*(p+k/2))>>((k&1)?0:4))&0xf;
						if(c[pn][cc])*(bmp+y*dy+x)=c[pn][cc];
					}
					x+=xx;
				}
				x-=xx*8;
				y+=yy;
				p+=4;
			}
}else{											//GRAYSCALE,4COLOR
			uchar	*p=cp+cn*16;
			for(int	j=0;j<8;j++){
				for(uchar b=0x80;b;b>>=1){
//					bool	f=((x>=swl)&&(x<=swr)&&(y>=swt)&&(y<=swb))^ct;
					bool	f=(!sw)||(((x>=swl)&&(x<=swr)&&(y>=swt)&&(y<=swb))^ct);
					if(f){
						int	cc=0;
						if(*p&b)cc|=1;
						if(*(p+1)&b)cc|=2;
						if(c[pn][cc])*(bmp+y*dy+x)=c[pn][cc];
					}
					x+=xx;
				}
				x-=xx*8;
				y+=yy;
				p+=2;
			}
}
			sp-=4;
		}
	}else{		//screen1,2
		bool	cf=(*(bw_area_adr+bw_cur_stt_adr)==3)&&(*(bw_area_adr+bw_text_scr_adr)==sn+1);
		uint	tl,tt,tr,tb,cl,ct,cr,cb;
		if(cf){
			tl=*(bw_area_adr+bw_text_win_adr);
			tt=*(bw_area_adr+bw_text_win_adr+1);
			tr=*(bw_area_adr+bw_text_win_adr+2)+tl-1;
			tb=*(bw_area_adr+bw_text_win_adr+3)+tt-1;
			cl=*(bw_area_adr+bw_cur_loc_adr)+tl;
			ct=*(bw_area_adr+bw_cur_loc_adr+1)+tt;
			cr=*(bw_area_adr+bw_cur_loc_adr+2)+cl-1;
			cb=*(bw_area_adr+bw_cur_loc_adr+3)+ct-1;
			if(cr>tr)cr=tr;
			if(cb>tb)cb=tb;
		}
		uchar	*sp=bw_area_adr+((sn==1)?bw_scr1_adr:bw_scr2_adr);
		uint32	pr=((sn==1)?0x01000000:0x03000000);
		uint32	c[16][16];
		uchar	*cp,*cpp,*lpp;
if(*(bw_area_adr+bw_col_mode_adr)==0x00){//COLOR_MODE_GRAYSCALE
		cp=bw_area_adr+bw_chr_adr;
		cpp=bw_area_adr+bw_chr_pal_adr;
		lpp=bw_area_adr+bw_lcd_pal_adr;
		for(int i=0;i<16;i++){
			ushort	pc=*(ushort*)(cpp+i*2);		//pal_cols=0-15x4
			for(int j=0;j<4;j++){
				uchar	lc=*(lpp+(pc&0x07));
				c[i][j]=((i&4)&&(j==0))?0:pr|(0x111111*lc);
				pc>>=4;
			}
		}
}else if(*(bw_area_adr+bw_col_mode_adr)==0x80){//COLOR_MODE_4COLOR
		cp=bw_area_adr+bw_chr_adr;
		cpp=bw_area_adr+bw_col_pal_adr;
		for(int i=0;i<16;i++){
			for(int j=0;j<4;j++){
				ushort	pc=*(ushort*)(cpp+i*32+j*2);	//pal_cols=0-15x4
				uint32	lc=((pc&0xf00)*0x1100)|((pc&0xf0)*0x110)|((pc&0xf)*0x11);
				c[i][j]=((i&4)&&(j==0))?0:pr|lc;
			}
		}
}else{											//16COLOR
		cp=bw_area_adr+bw_col_chr_adr;
		cpp=bw_area_adr+bw_col_pal_adr;
		for(int i=0;i<16;i++){
			for(int j=0;j<16;j++){
				ushort	pc=*(ushort*)(cpp+i*32+j*2);	//pal_cols=0-15x16
				uint32	lc=((pc&0xf00)*0x1100)|((pc&0xf0)*0x110)|((pc&0xf)*0x11);
				c[i][j]=(j==0)?0:pr|lc;
			}
		}
}
		for(int i=0;i<1024;i++){
			int	cn=*sp+((*(sp+1)&0x01)<<8)+((*(sp+1)&0x20)<<4);	//chr no=0-1023
			int	pn=(*(sp+1)&0x1e)>>1;		//pal no=0-15
			if((cf)&&(i/32>=ct)&&(i/32<=cb)&&(i%32>=cl)&&(i%32<=cr))pn=*(bw_area_adr+bw_cur_type_adr);
			int	xx=(*(sp+1)&0x40)?-1:1;		//h-mirror
			int	yy=(*(sp+1)&0x80)?-1:1;		//v-mirror
			uchar	x=(i%32)*8;if(xx<0)x+=7;
			uchar	y=(i/32)*8;if(yy<0)y+=7;
if(*(bw_area_adr+bw_col_mode_adr)==0xc0){	//COLOR_MODE_16COLOR
			uchar	*p=cp+cn*32;
			for(int	j=0;j<8;j++){
				for(uchar b=0x80;b;b>>=1){
					int	cc=0;
					if(*p&b)cc|=1;
					if(*(p+1)&b)cc|=2;
					if(*(p+2)&b)cc|=4;
					if(*(p+3)&b)cc|=8;
					*(bmp+y*dy+x)=c[pn][cc];
					x+=xx;
				}
				x-=xx*8;
				y+=yy;
				p+=4;
			}
}else if(*(bw_area_adr+bw_col_mode_adr)==0xe0){	//COLOR_MODE_16PACKED
			uchar	*p=cp+cn*32;
			for(int	j=0;j<8;j++){
				for(int k=0;k<8;k++){
					int	cc=((*(p+k/2))>>((k&1)?0:4))&0xf;
					*(bmp+y*dy+x)=c[pn][cc];
					x+=xx;
				}
				x-=xx*8;
				y+=yy;
				p+=4;
			}
}else{											//GRAYSCALE,4COLOR
			uchar	*p=cp+cn*16;
			for(int	j=0;j<8;j++){
				for(uchar b=0x80;b;b>>=1){
					int	cc=0;
					if(*p&b)cc|=1;
					if(*(p+1)&b)cc|=2;
					*(bmp+y*dy+x)=c[pn][cc];
					x+=xx;
				}
				x-=xx*8;
				y+=yy;
				p+=2;
			}
}
			sp+=2;
		}
	}
	DrawBitmap(bm,BPoint(0,0));
}
//------------------------------------------------------------------
BW_lcd_view::BW_lcd_view(BRect frame,char *title):BView(frame,title,B_NOT_RESIZABLE,B_WILL_DRAW|B_PULSE_NEEDED)
{
	viewf=0;
	bm=new BBitmap(BRect(0,0,223,143),B_RGB_32_BIT);
	ybm=new BBitmap(BRect(0,0,223,143),B_RGB_32_BIT);
	tbm=new BBitmap(BRect(0,0,143,223),B_RGB_32_BIT);
	uint32	*q;
	q=(uint32*)(bm->Bits());for(int i=0;i<144*224;i++)*(q++)=0;
	vbm=bm;
}

void BW_lcd_view::AttachedToWindow()
{
}

void BW_lcd_view::Draw(BRect rect)
{
	if(vbm)DrawBitmap(vbm,BPoint(0,0));
}

void BW_lcd_view::Pulse()
{
	uint32	*bmp=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	uint32	*p,*q;
	uchar	sx,sy;
	ushort	dc=*(ushort*)(bw_area_adr+bw_disp_adr);
	uint32	c;
if(*(bw_area_adr+bw_flag_init_adr)==0){
	if(*(bw_area_adr+bw_lcd_adr)==0){	//lcd sleep
		q=bmp;
		for(int i=0;i<144*224;i++)*(q++)=0;
	}else{
//border
		q=bmp;
if(*(bw_area_adr+bw_col_mode_adr)==0x00){//COLOR_MODE_GRAYSCALE
		c=*(bw_area_adr+bw_lcd_pal_adr+((dc&0x0700)>>8))*0x111111;
}else if(*(bw_area_adr+bw_col_mode_adr)==0x80){//COLOR_MODE_4COLOR
		uchar	pn=(dc&0xf000)>>12;
		uchar	cn=(dc&0x0300)>>8;
		uint32	pc=*(uint32*)(bw_area_adr+bw_col_pal_adr+pn*32+cn*2);
		c=((pc&0xf00)*0x1100)|((pc&0xf0)*0x110)|((pc&0xf)*0x11);
}else{//COLOR_MODE_16COLOR,COLOR_MODE_16PACKED
		uchar	pn=(dc&0xf000)>>12;
		uchar	cn=(dc&0x0f00)>>8;
		uint32	pc=*(uint32*)(bw_area_adr+bw_col_pal_adr+pn*32+cn*2);
		c=((pc&0xf00)*0x1100)|((pc&0xf0)*0x110)|((pc&0xf)*0x11);
}
		for(int i=0;i<144*224;i++)*(q++)=c;
//screen1
		if(dc&0x0001){
			sx=*(bw_area_adr+bw_scr_scrl_adr);
			sy=*(bw_area_adr+bw_scr_scrl_adr+1);
			dy=bw_sbm[1]->BytesPerRow()/4;
			p=(uint32*)(bw_sbm[1]->Bits());
			q=bmp;
			uchar	y=sy;
			for(int	ly=0;ly<144;ly++){
				uchar	x=sx;
				for(int lx=0;lx<224;lx++){
					c=*(p+y*dy+x);
					if(c>>24)*q=c;
					q++;
					x++;
				}
				y++;
			}
		}
//screen2
		if(dc&0x0002){
			sx=*(bw_area_adr+bw_scr_scrl_adr+2);
			sy=*(bw_area_adr+bw_scr_scrl_adr+3);
			bool	sw=(dc&0x20);	//win mode
			int	swl=sw?*(bw_area_adr+bw_scr2_win_adr):0;
			int	swt=sw?*(bw_area_adr+bw_scr2_win_adr+1):0;
			int	swr=sw?*(bw_area_adr+bw_scr2_win_adr+2)+swl:255;
			int	swb=sw?*(bw_area_adr+bw_scr2_win_adr+3)+swt:255;
			if((swr>255)||(swb>255))return;	//===error===
			bool	ct=(dc&0x10);	//ct
			dy=bw_sbm[2]->BytesPerRow()/4;
			p=(uint32*)(bw_sbm[2]->Bits());
			q=bmp;
			uchar	y=sy;
			for(int	ly=0;ly<144;ly++){
				uchar	x=sx;
				for(int lx=0;lx<224;lx++){
					bool	f=((lx>=swl)&&(lx<=swr)&&(ly>=swt)&&(ly<=swb))^ct;
					if(f){
						c=*(p+y*dy+x);
						if(c>>24)*q=c;
					}
					q++;
					x++;
				}
				y++;
			}
		}
//sprite
		if(dc&0x0004){
			dy=bw_sbm[0]->BytesPerRow()/4;
			p=(uint32*)(bw_sbm[0]->Bits());
			q=bmp;
			for(int	ly=0;ly<144;ly++)for(int lx=0;lx<224;lx++){
				c=*(p+ly*dy+lx);
				if((c>>24)>(*q>>24))*q=c;
				q++;
			}
		}
	}
}
//-----
	if(mode&2){
		uint32	*p=(uint32*)(bm->Bits());
		uint32	*q=(uint32*)(tbm->Bits());
		int		dy=bm->BytesPerRow()/4;
		if(mode&1){
			for(int y=0;y<224;y++)for(int x=0;x<144;x++)*(q++)=*(p+x*dy+(223-y))^0xffffff;
		}else{
			for(int y=0;y<224;y++)for(int x=0;x<144;x++)*(q++)=*(p+x*dy+(223-y));
		}
		vbm=tbm;
	}else{
		uint32	*p=(uint32*)(bm->Bits());
		uint32	*q=(uint32*)(ybm->Bits());
		if(mode&1){
			for(int y=0;y<224;y++)for(int x=0;x<144;x++)*(q++)=*(p++)^0xffffff;
			vbm=ybm;
		}else{
			vbm=bm;
		}
	}
	DrawBitmap(vbm,BPoint(0,0));
	if(viewf!=mode){
//		((BW_lcd_win*)Window())->changemode();
		if(mode&2)ResizeTo(143,223);else ResizeTo(223,143);
		if((mode&6)==6)MoveTo(0,16);else MoveTo(0,0);
		viewf=mode;
	}
}
//------------------------------------------------------------------
BW_seg_view::BW_seg_view(BRect frame,char *title):BView(frame,title,B_NOT_RESIZABLE,B_WILL_DRAW|B_PULSE_NEEDED)
{
	viewf=0;
	bm=new BBitmap(BRect(0,0,223,15),B_RGB_32_BIT);
	tbm=new BBitmap(BRect(0,0,15,223),B_RGB_32_BIT);
	uint32	*q;
	q=(uint32*)(bm->Bits());for(int i=0;i<16*224;i++)*(q++)=0;
	q=(uint32*)(tbm->Bits());for(int i=0;i<16*224;i++)*(q++)=0;
	vbm=bm;
	MoveTo(BPoint(0,144));
}

void BW_seg_view::AttachedToWindow()
{
}

void BW_seg_view::Draw(BRect rect)
{
	if(vbm)DrawBitmap(vbm,BPoint(0,0));
}

void BW_seg_view::Pulse()
{
	uint32	*bmp=(uint32*)(bm->Bits());
	int		dy=bm->BytesPerRow()/4;
	uint32	*p,*q;
	q=bmp;
	for(int i=0;i<16*224;i++)*(q++)=0;

	ushort	f=*(ushort*)(bw_area_adr+bw_seg_adr);
	f&=0x003f;
	if(!*(bw_area_adr+bw_flag_init_adr))f|=0x0800;	//power
	
	if(((f&0x06)==0x02)&&((mode&2)==0)){mode|=2;((BW_app*)be_app)->bw_lw->changemode();}
	if(((f&0x06)==0x04)&&((mode&2)==2)){mode&=~2;((BW_app*)be_app)->bw_lw->changemode();}

	for(int i=0;i<16;i++){
		int	j=(mode&4)?i+16:i;
		if(f&(1<<i)){
//for(int i=((mode&4)?16:0);i<((mode&4)?22:6);i++){
//if(segpos[i]!=255){
			for(int y=0;y<16;y++){
				q=bmp+segpos[j]+y*dy;
				for(int x=0;x<16;x++){
					if(segpat[j*16+y]&(0x8000>>x))*q=0xffffffff;
					q++;
				}
			}
		}
	}
//-----
	if(((mode&6)==2)||((mode&6)==4)){
		uint32	*q=(uint32*)(tbm->Bits());
		uint32	*p=(uint32*)(bm->Bits());
		int		dy=bm->BytesPerRow()/4;
		if(mode&4)for(int y=0;y<144;y++)for(int x=0;x<16;x++)*(q++)=*(p+(15-x)*dy+y);
		else for(int y=0;y<224;y++)for(int x=0;x<16;x++)*(q++)=*(p+x*dy+(223-y));
		vbm=tbm;
	}else{
		vbm=bm;
	}
	DrawBitmap(vbm,BPoint(0,0));
	if(viewf!=mode){
//		((BW_lcd_win*)Window())->changemode();
		if((mode&6)==0){
			ResizeTo(223,15);
			MoveTo(BPoint(0,144));
		}else if((mode&6)==2){
			ResizeTo(15,223);
			MoveTo(BPoint(144,0));
		}else if((mode&6)==4){
			ResizeTo(15,143);
			MoveTo(BPoint(224,0));
		}else if((mode&6)==6){
			ResizeTo(143,15);
			MoveTo(BPoint(0,0));
		}
		viewf=mode;
	}
}
